/* Given a sequence u(n) [closure] with asymptotic expansion
 * u_n = a0 + a1/n^al + a2/n^{2al} + ... where the a_i are
 * rational numbers, find as many a_i as possible. */

/* vu(N) = [u_1, ..., u_N] */
Asympvec(vu, al = 1, LIM = 100) =
{ my(B = getlocalbitprec(), v = [], W, LB, U, R, B1);

  LB = al * log(B)/log(2);
  [B1, W] = Limitinit(al);
  localbitprec(B1); al = bitprecision(al, B1);
  U = vu(#W); R = dirpowers(#W, al);
  for (k = 0, oo,
    my(p, q, a, z = sum(i = 1, #W, W[i] * U[i]));
    z = bitprecision(z, max(B - floor(k*LB/2), 32));
    [p, q] = lindep([1, z]); a = -p/q;
    if (exponent((z-a) * q^2) > -16 || #v >= LIM, return (v));
    v = concat(v, a); /* found a new a_i */
    U = vectorv(#U, n, (U[n] - a) * R[n]));
}
/* u(n) = u_n */
Asymp(u, al = 1, LIM = 100) =
  Asympvec(N -> vector(N, n, u(n)), al, LIM);
