Besselk0init() =
{ my(B = getlocalbitprec(), E, n, T, c);

  localbitprec(32);
  E = B * log(2); T = E / 25;
  n = ceil(E^2 / (13 * T));
  c = vector(n); c[1] = - 1/8;
  for (m = 2, n, c[m] = -c[m-1] * (2*m-1)^2 / (8 * m));
  localbitprec(2 * B);
  return ([CFtoEuler(Quodif(c)), E, T]);
}

/* Data output by Besselk0init(). */
Besselk0(x, Data = 0) =
{
  if (!Data, Data = Besselk0init());
  my([CFAB, E, T] = Data, k);
  if (x < T, error("x too small for Besselk0"));
  k = sqrt(Pi / (2 * x)) * exp(-x);
  if (x < E,
    my(n = ceil(E^2 / (13 * x)));
    k *= 1 + CFEulereval(CFAB, n \ 2, x));
  return (k);
}
