/* Zeros for Bessel functions J_nu or Y_nu. */

/* f = besselj or bessely. */
Besselrefine(f, nu, x) =
{ my(T = (z -> 1 / ((nu / z) - f(nu + 1, z) / f(nu, z))));
  Newtonrefine(T, x);
}

Besseljzeros(nu, N) =
{ my(z = (nu/2 - 1/4)*Pi);
  vector(N, n, Besselrefine(besselj, nu, z += Pi));
}

Besselyzeros(nu, N) =
{ my(z = (nu/2 - 3/4)*Pi);
  vector(N, n, Besselrefine(bessely, nu, z += Pi));
}
