/* Fourier expansion of a function g of period T to k terms.
 * Returns [a0, C, S] with a0 the constant term, C the vector
 * of cosine coefficients and S the sine coefficients. */

Fourier(g, T, k) =
{ my(t = 2*Pi / T, T2 = T / 2);

  return (intnum(x = -T2, T2,
                 my(z = exp(I * t * x), e = powers(z, k-1, z));
                 g(x) * [1, real(e), imag(e)]) / T2);
}
