/* Compute S(p;z) using Gross-Koblitz, p >= 67 */
Srp(p, z) =
{ my(p2 = p^2, p5 = (p-1) \ 5, zp, Z, H, S1, S2, r0);
  my(x = 'x, N = 1250*x^3 - 1750*x^2 + 750*x - 96);

  zp = Mod(z, p2)^p; Z = 1; S1 = 0; H = 0;
  for (r = 1, p5,
    my(R = 5*r, D = (R * (R-1) * (R-2) * (R-3) * (R-4)) % p2);
    Z *= zp / r^5 * D;
    H = (H + subst(N, x, r) / D) % p;
    S1 += Z * (1 + p * R * H));
  zp = Mod(z, p); Z = Mod(Z, p); S2 = 0; r0 = p5 + 1;
  my(b = 5 * r0 - (p-1)); /* 2 <= b <= 5 */
  Z *= b! * (5 - b)! * (-1)^b;
  for (r = r0, (2*(p-1)) \ 5,
    Z *= zp / r^5;
    if (r != r0, my(R = 5 * r);
                 Z *= (R+1) * R * (R-1) * (R-2) * (R-3));
    S2 += Z);
  my(a = lift(S1 - p * lift(S2))); /* S = a (mod p^2) */
  return (p2^2 + (a - (1 + a) * p2) % ((p - 1) * p2));
}
