/* int_{-1}^1 (1-x^2)^{e/2} f(x) dx with e = -1 or 1. */
IntGaussChebyshevinit(e = -1, N = 0) =
{ my(B = getlocalbitprec(), X, W);

  if (!N, N = ceil(B / 4));
  /* This assumes r >= 2. See text. */
  localbitprec(B + 32);
  X = vector(N);
  if (e == -1,
    my(c = exp(I*Pi / (2*N)));
    X = real(powers(c^2, N - 1, c));
    W = vector(N, j, Pi / N)
  , /* else */
    my(c = exp(I*Pi / (N + 1)));
    my(Z = powers(c, N - 1, c));
    X = real(Z);
    W = Pi / (N + 1) * imag(Z)^2);
  return ([X, W]);
}

IntGaussChebyshev(f, e = -1, XW = 0) =
{
  if (type(XW) == "t_INT", XW = IntGaussChebyshevinit(e, XW));
  return (SumXW(f, XW));
}
