/* int_0^oo x^al e^{-x} f(x) dx with al > - 1
 * assumed exact. */

IntGaussLaguerreinit(al = 0, ct = 1/2) =
{ my(B = getlocalbitprec(), N, X, W, lt, lu, va, vb);

  if (type(ct) == "t_VEC", return (ct));
  N = ceil(ct * B);
  va = vector(N + 1, n, 2*n - 1 + al);
  vb = vector(N, n, n * (n + al));
  X = Orthopolyroots(va[1..N],
                     vb[1..N-1], N); /* roots of L_N */
  lu = 1 / factorial(N + 1);
  lt = (-1)^(N + 1) * lu; /* leading term of L_{N+1} */
  W = vector(N);
  for (i = 1, N,
    my(Y = Orthopolyeval(va, vb, N + 1, X[i]) * lt);
    W[i] = X[i] / Y^2);
  W *= lu * gamma(N + al + 1) / (N + 1);
  return (bitprecision([X, W], B + 32));
}

IntGaussLaguerre(f, a = 0, al = 0, XW = 1/2) =
{
  XW = IntGaussLaguerreinit(al, XW);
  return (exp(-a) * SumXW(x -> f(x + a), XW));
}
