/* Assume r / (b - a) >= 1. See text. */
IntGaussLegendreinit(N = 0) =
{ my(B = getlocalbitprec(), X, Y, W, c);

  if (type(N) == "t_VEC", return (N)); /* already an init */
  if (!N, N = ceil(B / 4));
  if (N % 2, N++); /* We want N even, see text. */
  localbitprec(B + 32);
  [X, Y] = Legendreroots(N);
  c = 2 * factorial(N - 1)^2 / N^2;
  W = vector(#X, i, c * (1 - X[i]^2) / Y[i]^2);
  return (bitprecision([X, W], B + 32));
}

/* Simple Gauss-Legendre integration. */
IntGaussLegendre(f, a, b, XW = 0) =
{ my(B = getlocalbitprec(), S, m, p);
  my([X, W] = IntGaussLegendreinit(XW));

  localbitprec(B + 32);
  m = (b - a) / 2;
  p = (b + a) / 2;
  S = sum(i = 1, #X, my(y = m * X[i]);
                     W[i] * (f(p + y) + f(p - y)));
  return (bitprecision(m * S, B));
}
