/* Assume that f is a nice function on [a, oo[ with a > -1
 * which has an asymptotic expansion at infinity of the type
 * f(x) = sum_{j >= 0} a_j / x^{j*al+be}
 * with al>0 and be>1. Compute int_a^oo f(x) dx using
 * generalized Gauss-Legendre. */
IntGaussa_ooinit(alf = [1, 2], XW = 0) =
{ my([al, be] = alf);
  return (IntGaussJacobiinit((be - 1) / al - 1, XW));
}

IntGaussa_oo(f, a = 1, alf = [1, 2], XW = 0) =
{
  if (a < -1, error("must have a > -1 in IntGaussa_oo"));
  if (a < 1, return (IntGaussa_oo(x -> f(x+a-1), 1, alf, XW)));
  my([al, be] = alf, c = 1 / al, d = c * be);
  if (type(XW) != "t_VEC",  XW = IntGaussa_ooinit(alf, XW));
  return (c * IntGaussJacobi(x -> f(x^(-c)) * x^(-d),
                             0, a^(-al), d - c - 1, XW));
}
