/* int_{-oo}^{oo} f(x) / cosh(pi x) dx. */

IntGausscoshinit(n = 0) =
{ my(B = getlocalbitprec(), X, W);

  if (!n, n = ceil(B / 4));
  if (n%2, n++);
  my(N = 1 + n >> 1);
  my(va = vector(N, k, (k - 1) * (2*k - 1) + 1/4));
  my(vb = vector(N - 1, k, k^2 * (2*k - 1)^2 / 4));
  my([P, Q] = Orthopolyrec([va, vb], 1));
  localbitprec(5 * B / 4);
  X = Orthopolyroots(va, vb, N);
  W = subst(Q / (2 * P'), 'x, X);
  return (bitprecision([sqrt(X), W], B + 32));
}

IntGausscosh(f, iseven = 0, XW = 0) =
{ my(B = getlocalbitprec(), S);
  if (type(XW) == "t_INT", XW = IntGausscoshinit(XW));
  S = if (iseven, 2 * SumXW(f, XW)
                , SumXW(x -> f(x) + f(-x), XW));
  return (bitprecision(S, B));
}
