/* int_{-oo}^oo f(x)w(x) dx with w(x)= x/(exp(2 pi x)-1)
 * on [0, oo[ and w(-x) = w(x). */
IntGaussexpinit(N = 0) =
{ my(B = getlocalbitprec(), v, QP, P, Q, X, W);

  if (!N, N = ceil(B / 4));
  if (N%2 == 0, N++);
  localbitprec(3*B/2 + 32);
  bernvec(N); /* initialize Bernoulli cache */
  v = Quodif(vector(N+1, k, (-1)^(k-1)*bernfrac(2*k)/(2*k)));
  QP = CFback(N, m -> v[m + 2] / 'x);
  [Q, P] = [denominator(QP) / (12 * 'x), numerator(QP)];
  X = polrootsreal(P);
  if (#X != poldegree(P),
      error("loss of accuracy in polrootsreal"));
  W = subst(Q / (2 * P'), 'x, X);
  return (bitprecision([sqrt(X), W], B + 32));
}

IntGaussexp(f, iseven = 0, XW = 0) =
{ my(B = getlocalbitprec(), S);
  if (type(XW) == "t_INT", XW = IntGaussexpinit(XW));
  S = if (iseven, 2 * SumXW(f, XW)
                , SumXW(x -> f(x) + f(-x), XW));
  return (bitprecision(S, B));
}
