/* int_a^oo F(x) dx where F = fg, and g periodic such
 * that g(H * (n + C)) = 0 for n >> 1. */
IntoscOouraMoriinit(H, C = 0) =
{ my(B = getlocalbitprec(), K = 28/10);
  my(N, h, M, X, W, ehpow, t);

  localbitprec(32);
  N = ceil(B*log(B) / 1.5);
  h = log(2*N*Pi / log(N)) / N;
  localbitprec(B + 32); h = bitprecision(h, B + 32);
  M = H / h; t = (C - N) * h;
  ehpow = powers(exp(h), 2 * N, exp(t));
  X = vector(2 * N + 1); W = vector(2 * N + 1);
  for (n = 1, 2 * N + 1,
    my(D, E, phi, phip);
    if (t, /* et = exp(t) */
      my(et = ehpow[n], emt = 1 / et);
      my(sht = (et - emt) / 2, cht = (et + emt) / 2);
      E = exp(-K * sht); D = 1 - E;
      phi  = t / D; phip = (1 - K * cht * phi * E) / D;
    ,
      phi  = 1 / K; phip = 1 / 2);
    t += h;
    X[n] = M * phi; W[n] = H * phip);
  return ([X, W]);
}

IntoscOouraMori(f, H, C = 0, XW = 0) =
{
  if (!XW, XW = IntoscOouraMoriinit(H, C));
  return (SumXW(f, XW));
}
