IntoscOouraMori2init(H, C = 0) =
{ my(B = getlocalbitprec());
  my(a, b, N, h, M, X, W, ehpow, t);

  localbitprec(32);
  N = ceil(B*log(B) / 1.5);
  h = log(2*N*Pi / log(N)) / N;
  localbitprec(B + 32); h = bitprecision(h, B + 32);
  M = H / h; t = (C - N) * h;
  b = 1 / 4;
  a = bestappr(5 * log(M) / sqrt(M), 10^4);
  ehpow = powers(exp(h), 2 * N, exp(t));
  X = vector(2 * N + 1); W = vector(2 * N + 1);
  for (n = 1, 2 * N + 1,
    my(D, E, phi, phip);
    if (t, /* et = exp(t), em = exp(-t) */
      my(et = ehpow[n], emt = 1 / et);
      E = exp(-2 * t - a * (1-emt) - b * (et-1)); D = 1 - E;
      phi  = t / D;
      phip = (1 + (-2 - a * emt - b * et) * E * phi) / D;
    ,
      phi  = 4 / (4*a + 9); /* specific to b = 1/4 */
      phip = 1/2 + (8*a - 2) / (4*a + 9)^2);
    t += h;
    X[n] = M * phi; W[n] = H * phip);
  return ([X, W]);
}

IntoscOouraMori2(f, H, C = 0, XW = 0) =
{
  if (!XW, XW = IntoscOouraMori2init(H, C));
  return (SumXW(f, XW));
}
