/* int_a^oo F(x)dx where F = f g with f nonoscillating and g
 * oscillating with quasi half-period H and int_{n H}^{(n+1) H}
 * alternating. H must be given with a larger accuracy than the
 * default. */

Intoscalt(F, H, XW = 0) =
{ my(B = getlocalbitprec(), U);

  localbitprec(B + 32);
  if (!XW, XW = IntGaussLegendreinit());
  U = (n -> (-1)^(n-1)*IntGaussLegendre(F, (n-1)*H, n*H, XW));
  return (bitprecision(Sumalt(U), B));
}
