/* int_0^oo sin(t)^{k_1} / t^{k_2} dt, assuming convergence. */
Intperiodicsine(k1, k2) =
{ my(B = getlocalbitprec(), S);

  if (k2 >= k1 + 1, error("not integrable at 0"));
  if (k2 == 1 && (k1 % 2 == 0), error("not integrable at oo"));
  localbitprec(5/4 * B);
  S = Intperiodic(t -> 1 / t^k2,
                  [t -> sin(t)^k1, k1], 2*Pi, 2*Pi)
    + intnum(t = if (k1 >= k2, 0, [0, k1 - k2]),
             2*Pi, sinc(t)^k1 * t^(k1 - k2));
  return (bitprecision(S, B));
}
