/* Returns either 0 if a = b, or [s, a, b, u] such that the
 * integral is equal to s int_a^b f(ux) dx with s,u = 1 or -1
 * and a < b. */
Intchangevar(a, b) =
{
  if (a == b, return ([0, 0, 0, 0]));
  if (a == oo, return ([-1, b, oo, 1]),
      a ==-oo, return ([1, -b, oo, if (b == oo, 1,-1)]),
      /* now a is finite */
      b == oo, return ([1, a, oo, 1]),
      b ==-oo, return ([-1, -a, oo, -1]),
      return ([1, a, b, 1]));
}

/* Driver routine. c is set to a complex number in last resort
 * (see text). */
Intrat(F, a, b, c = "unset") =
{ my(B = getlocalbitprec(), s, u, R, S);
  my(X = variable(F), D = denominator(F));

  [s, a, b, u] = Intchangevar(a, b);
  if (!s, return (0));
  if (u == -1, F = subst(F, X, -X));
  localbitprec(B + 32);
  if (precision(D) == oo ||
      exponent(polresultant(D, D')) >= -B / poldegree(D),
    S = Intratdec(F, a, b)
 ,
    R = polrootsbound(D);
    if (a > 1.1 * R,
      S = IntratTaylor_oo(F, a, b, R)
    ,
      if (a == -oo || b == oo, error("Intrat fails"));
      S = IntratTaylorc(F, a, b, c)));
  if (!imag(F), S = real(S));
  return (bitprecision(s * S, B));
}
