/* Compute the integral from N to oo of a rational function F.
 * It is assumed that N is sufficiently large, more precisely
 * N > 2 max(1, max|a|). */
Intrata_oo(F, N) =
{ my(B = getlocalbitprec(), S, vx, lim, ser, r);

  if (poldegree(F) >= -1, error("infinite integral"));
  vx = variable(F);
  r = polrootsbound(denominator(F)); /* max |alpha| */
  if (N < 2*r, error("N not large enough"));
  localbitprec(32);
  lim = ceil(B * log(2) / log(N/r)) + 1;
  localbitprec(B + 32);
  ser = 1. * subst(F, vx, 1/vx) + O(vx^(lim+2));
  S = 0.;
  forstep (k = lim, 1, -1, S = (polcoef(ser, k+1) / k + S)/N);
  return (bitprecision(S, B));
}
