/* Hardy Z function. */
LfunHardy(Ldata, t) =
{
  Ldata = Lfuninit(Ldata, abs(t), Ldata.k / 2);
  my([Vga, k, N, w] = Ldata[1][3..6], d = #Vga);
  t = bitprecision(t, Ldata.prec);
  my(k2 = k/2, z = k2 + I*t, E);
  E = (d * (k2 - 1) + vecsum(Vga)) / 4;
  return (exp(d * t * atan(t / k2) / 2) / norm(z)^E
          * real(Lfun(Ldata, z, 1) / sqrt(w)));
}

Lfunplot(Ldata, range = [0,50]) =
{ my([T, Tmax] = range);

  localbitprec(32);
  Ldata = Lfuninit(Ldata, vecmax(abs(range)), Ldata.k / 2);
  ploth(t = T, Tmax, LfunHardy(Ldata, t));
}
