/* Check if Ldata (assumed complete with root number and poles)
 * is an L-function with functional equation. If consistent,
 * the result should be close to 0 to current accuracy. */
Lfuncheckfeq(Ldata, vv = 0) =
{ my(t0 = 355 / 339 + I / 7, a, b);

  if (#Ldata == 2, Ldata = Ldata[1]);
  my([k, N, w, R] = Ldata[4..7]);
  if (!vv, vv = Lfunthetainit(Ldata));
  a = Lfuntheta(Ldata,  1 / t0,  vv) + w * conj(R);
  b = Lfuntheta(Ldata, conj(t0), vv) + w * conj(R);
  return (a / (w * t0^k * conj(b)) - 1);
}
