Lfunconductor(Ldata, maxcond=10000, steps=15)=
{ my(vv, th0, g, w, st);

  if (#Ldata == 2, Ldata = Ldata[1]);
  if (type(maxcond) != "t_VEC", maxcond = [9/10, maxcond]);
  my([minN, maxN] = maxcond);
  my([k, N, w, R] = Ldata[4..7], w2);
  if (w == oo || R == oo, error("Missing residue/root number"));
  localbitprec(192);
  w2 = 1 / sqrt(w);
  vv = Lfunthetainit(Ldata, 1, ceil(maxN));
  th0 = (t -> -R + Lfuntheta0(Ldata, t, vv));
  localbitprec(128);
  my(Uz = w2 * exp((k/2) * 0.1) * th0(exp(0.1)));
  if (exponent(imag(Uz)) > -32,
    g = (N -> imag(w2 * th0(1 / sqrt(N)))) \\ Im(U) != 0, use U
  ,
    g = (N -> my(n = 1 / sqrt(N)); \\ use U'
              real(w2 * (k/2 * th0(n) + th0'(n) * n))));
  ploth(t = minN, maxN, g(t)); \\ visual control
  st = (maxN - minN)^(1 / steps);
  \\ 2: refine until a zero is found; 4: multiplicative search
  w = solvestep(t = minN, maxN, st, g(t), 2 + 4);
  return (if (#w == 1, w[1], Vec(w)));
}
