/* Lfuntheta at 2^{1/2} and 2^{-1/2} simultaneously.
 * If vv is set keep the current accuracy, otherwise increase
 * it to perform the computation. */
Lfunthetaroot2(Ldata, vv = 0)=
{ my(vK, L, t, Vga, an, K, B = getlocalbitprec(), d);

  localbitprec(if (!vv, B + 32, B));
  if (!vv, vv = Lfunthetainit(Ldata));
  Vga = Ldata.Vga; d = #Vga;
  if (d == 1 || (d == 2 && abs(Vga[1] - Vga[2]) == 1),
    return ([Lfuntheta(Ldata, sqrt(2), vv),
             Lfuntheta(Ldata, sqrt(2) / 2, vv)]));
  [an, K] = vv; L = #an; t = 1 / sqrt(2 * Ldata.N);
  vK = vector(L, n, K((n * t)^(2/d)));
  return ([sum(n=1, L \ 2, an[n] * vK[2 * n]),
           sum(n=1, L, an[n] * vK[n])]);
}

