/* Compute lim_{n -> oo} u(n) using Lagrange interpolation,
 * assuming u(n) expands in integral powers of 1/n. */
Limit1(u) =
{ my(B = getlocalbitprec(), N, C, S);

  N = ceil(LimitmulNZagier(1) * B);
  localbitprec(B + Limitaccuracy(1) * N);
  C = binomial(N);
  S = sum(n = 1, N, (-1)^(N-n) * C[n+1] * n^N * u(n), 0.);
  return (bitprecision(S / N!, B));
}
