/* Compute lim_{n -> oo} u(n) using Lagrange interpolation,
 * assuming u(n) expands in powers of 1/n^2. */
Limit2(u) =
{ my(B = getlocalbitprec(), N, C, S);

  N = ceil(LimitmulN(2) * B);
  localbitprec(B + Limitaccuracy(2) * N);
  C = binomial(2*N);
  S = sum(n = 1, N, (-1)^(N - n) * C[N - n + 1]
                             * n^(2 * N) * u(n), 0.);
  return (bitprecision(2 * S / (2 * N)!, B));
}
