/* SUM = 1: Sum, SUM = 0: Limit */
LimitSidicommon(f, SUM, mu) =
{ my(B = getlocalbitprec(), eps = 2.^(-B), fail = 0);
  my(M = List(), N = List(), E = oo, Ekeep = 0, Wkeep = 0);
  my(S, t, Wp, W, fn);

  localbitprec(mu * B + 32);
  S = 0.; fn = t = f(1);
  for (n = 1, oo, \\ fn = f(n)
    my(e = oo, c);
    S += t; t = f(n + 1);
    if (!SUM,
      my(fN = t); t -= fn; fn = fN); \\ t = f(n + 1) - f(n)
    if (!t, t = eps);
    /* Sidi's W algorithm */
    c = 1. / (n * t); listput(M, S * c); listput(N, c);
    if (n == 1, Wp = S; next);
    forstep (s = n - 1, 1, -1,
      my(d = s * n / (n - s));
      M[s] = d * (M[s] - M[s + 1]);
      N[s] = d * (N[s] - N[s + 1]));
    if (N[1], /* if N[1] = 0, count as failure */
      W = M[1] / N[1];
      e = exponent(W - Wp); if (e < -B, break));
    if (fail++ >= 10,
      warning("reached accuracy of ", -Ekeep, " bits.");
      B = -Ekeep; W = Wkeep; break);
    if (e < E, fail = 0; E = e; Ekeep = E; Wkeep = W);
    Wp = W);
  return (bitprecision(W, B));
}

LimitSidi(f, mu = 1.56) = LimitSidicommon(f, 0, mu);

/* sum_{n >= 1} f(n) using LimitSidi */
SumSidi(f, safe = 1) =
  LimitSidicommon(f, 1, if (safe, 1.56, 1));

SumaltSidi(f) =
  LimitSidicommon(n -> (-1)^(n - 1) * f(n), 1, 1);
