/* Find the required accuracy constant c for extrapolation,
 * so that bitprec = B + c*N: */
Limitaccuracy(al)=
{ my(a, T, A = 1 / al);

  localbitprec(32); T = intnuminit(0, 1);
  a = solve(b = 1e-5, 1, log(b) +
      intnum(x = 0, b + 1, if (x == 1, A, (x^A-1)/(x-1)), T));
  return (-log(a) / log(2));
}

/* Give magic constant corresponding to multiplier mul = 1,
 * obtained using the Limitmagic program. Only given for
 * al >= 1/4. */
LimitmulN(al) =
{ my(c);

  localbitprec(32);
  c = if (al >= 2,   0.2270,
          al >= 1,   0.3318,
          al >= 1/2, 0.6218,
          al >= 1/3, 1.2,
          al >= 1/4, 3, error("unsupported alpha"));
  return (c);
}
