/* [v1, ..., vN] -> [v1/2+...+vN, v2/2+...+vN, ..., vN/2]. */
Vecsumrev(v) =
{ my(N = #v, S = 0.);
  forstep (n = N, 1, -1, S += v[n]; v[n] = S - v[n]/2);
  return (v);
}
/* Test on sum_{0 < j <= n} 1/j^(al+1) - 1/(2n^(al+1)). */
Tst(N, al) =
{ my(v = Vecsumrev( Limitweights(N, al) ));
  return (sum(n = 1, #v, v[n] / n^(al + 1)));
}
/* Magic constant when asymp is ~ sum a_i n^(-al*i) */
Limitmagic(N, al) = localbitprec(10 * N);\
  -log(2) * N / log(abs(Tst(N, al) - zeta(al + 1)));
