/* Low accuracy approximation of the constants C_a = -W_a(-1/e)
 * and r_a = log(2) / log(abs(C_a)), where W_a is the a-th
 * complex branch of the Lambert function. */
LimitmulNZagier(a = 1) =
{ my(F, C = I);
  localbitprec(64);
  (F(x) = log(x) - x + 1 - 2 * Pi * I * a);

  for (i = 1, 6, C -= C * F(C) / (1 - C));
  log(2) / log(abs(C)); /* C ~ C_a */
}

