/* Let u be a sequence defined by u(0)=u0, u(1)=u1, and the
 * recursion u(n+1)=a(n+1)u(n)+b(n)v(n-1). Assume known that
 * u(n)/f(n) tends to a constant C with asymptotic expansion
 * in powers of 1/n^{al}. Compute C. */

Limitrec2(a, b, u0, u1, f, al = 1, mul = 10) =
{
  Limitvec(N ->
    my(V = vector(mul * N));
    V[1] = u1 * 1.;
    V[2] = a(2) * V[1] + b(1) * u0;
    for (n = 2, mul * N - 1, V[n+1] = a(n+1)*V[n]+b(n)*V[n-1]);
    vector(N, n, V[mul * n] / f(mul * n)));
}

/* Example of the Motzkin sequence. */
LimitMotzkin(mul = 10) =
{ my(a = n -> (2*n - 1) / (n + 1));
  my(b = n -> 3*(n - 1) / (n + 2));
  my(f = n -> 3^n / n^(3/2));
  Limitrec2(a, b, 0, 1, f, 1, mul);
}
