/* [L_i(0), i=1..N], where L_i is i-th Lagrange interpolation
 * polynomial at the n^al, n <= N (such that L_i(i^al) = 1) */
Limitweights(N, al = 1) =
{ my(V, W);
  if (al == 1, W = vector(N);
               W[1] = (-1)^(N-1)/factorial(N-1);
               for (n=2, N, W[n] = W[n-1] * (n-1-N) / n);
               for (n=2, N, W[n] *= n^N),
      al == 2, W = vector(N);
               W[1] = (-1)^(N-1)/(factorial(N-1)^2*(N^2+N)>>1);
               for (n=2, N, W[n] = W[n-1] * (n-1-N) / (N+n));
               for (n=2, N, W[n] *= n^(2*N)),
      V = dirpowers(N, al);  /* V[n] = n^al */
      W = vector(N, n, V[n]^(N-1)
                 / vecprod([ V[n]-V[j] | j <- [1..N][^n] ])));
  return (W);
}
