/* Compute log(Gamma(x)) */
Lngamma(x) =
{ my(B = getlocalbitprec(), k, N, Nx, C, N2, S1, S2, res);

  localbitprec(32);
  k = max(10, B*log(2) / (1 + lambertw(Pi)));
  k = 2 * ceil(k / 2); /* ensure that k is even */
  bernvec(k \ 2 + 1); /* initialize Bernoulli cache */
  C = bernreal(k+2) / ((k+1) * (k+2));
  N = max(1, ceil((abs(C) * 2.^B)^(1/(k+1)) + 1 - real(x)));
  localbitprec(B);
  Nx = N + x - 1; N2 = Nx^(-2);
  S1 = log(prod(m = 0, N - 1, m + x, 1.));
  S2 = 0;
  forstep (j = k, 2, -2, S2 = bernreal(j) / ((j-1)*j)+S2 * N2);
  res = (Nx + 1/2) * log(Nx) - N
        + log(2*Pi)/2 + 1 - x - S1 + S2/Nx;
  return (res - 2*Pi*I * round(imag(res) / (2*Pi)));
} /* principal determination */

Gamma(x) = exp(Lngamma(x));
