/* Given a symmetric positive definite matrix A, finds an
 * upper triangular matrix R such that R~ * R = A. */
MatCholeskyGauss(A) =
{ my(B = qfgaussred(A), N = #A, s);

  for (i = 1, N,
    B[i,i] = s = sqrt(B[i,i]);
    for (j = 1, N, if (i != j, B[i,j] *= s)));
  return (matqr(B)[2]);
}
