/* Return a closure computing K(x^(d/2)). When K(t) is simple,
 * give the formula. Otherwise use the power series for t < T,
 * else the continued fraction. */
Mellininvtech(Vga, C = 0)=
{ my(B = getlocalbitprec(), S, L);

  if (Vga == [0],    return (x -> 2*exp(-Pi*x)),
      Vga == [1],    return (x -> 2*sqrt(x)*exp(-Pi*x)),
      Vga == [0, 1], return (x -> 2*exp(-2*Pi*x)));
  if (!C, C = if (#Vga == 2, 9, 10));
  localbitprec(32); my(T = log(2) * B / C^2);
  localbitprec(B);
  S = Mellininvsmallinit(Vga, C);
  L = Mellininvlargeinit(Vga, C);
  return (x -> if (abs(x) < T, Mellininvsmall(Vga, x, S, C),
                               Mellininvlarge(Vga, x, L, C)));
}

/* Return a closure computing K(x) */
Mellininv(Vga) = x -> Mellininvtech(Vga)(x^(2 / #Vga));
