Mellininvlargeinit(Vga, C = 9) =
{ my(B = getlocalbitprec(), M, N, e);

  localbitprec(32); N = ceil(B * C^2 * log(2) / (16 * Pi));
  localbitprec(B); M = Mellininvlargecoefs(Vga, N);
  if (type(M) == "t_POL", return (M)); /* finite expansion */
  /* Divide expansion by 1 - z/Pi to avoid divisions by 0 */
  localbitprec(4 * B / 3); e = 1 / Pi;
  for (i = 2, #M, M[i] += M[i - 1] * e);
  return (CFtoEuler(Quodif(M)));
}

/* K_Vga( t^(d / 2) ), t > E / C^2 is large */
Mellininvlarge(Vga, t, M = 0, C = 9) =
{ my(B = getlocalbitprec(), d = #Vga, td, T, A, n, P);
  my(NEWB);

  if (!M, M = Mellininvlargeinit(Vga, C));
  A = 1 - d + vecsum(Vga);
  localbitprec(32); td = abs(t);
  NEWB = max(64, ceil(B+64 - (Pi*d*td - A*log(td)/2) / log(2)));
  localbitprec(NEWB); t = bitprecision(t, NEWB); T = Pi * t;
  P = sqrt(2^(d+1) / d * t^A) * exp(-d*Pi*t);
  /* finite expansion ? */
  if (type(M) == "t_POL", return (P * subst(M, 'x, 1 / T)));
  localbitprec(64);
  n = min(2 * #M[1], ceil((log(2) * B)^2 / (C^2 * td)));
  localbitprec(B);
  return (P * CFEulereval(M, n\2, T) * (T - 1 / Pi));
}
