Mellininvsmallinit(Vga, C = 9) =
{ my(B = getlocalbitprec(), d = #Vga, x = 'x, LA0, LA1, N, LA);
  my(P, m, L, G, M);

  localbitprec(32);
  L = ceil(2*log(2) * B / (d * lambertw(C^2 / (Pi*exp(1)))));
  localbitprec(B * (1 + d * Pi / C^2));
  LA0 = vecsort([ a | a <- Vga, a%2 == 0 ]);
  LA1 = vecsort([ a | a <- Vga, a%2 == 1 ]);
  LA = if (#LA0 == 0, [LA1],
           #LA1 == 0, [LA0], [LA0, LA1]);
  N = #LA;
  P = vector(N, j, #LA[j]);
  m = vector(N, j, 2 - vecmin(LA[j]));
  G = vector(L + 1);
  M = matrix(N, d + 1);
  for (j = 1, N,
    my(v = vector(d, i, (x + Vga[i] + m[j]) / 2));
    my(T = vecprod(v), p = P[j] + 1);
    G[1] = prod(i = 1, d, gamma(v[i] + O(x^p)));
    for (n = 1, L, G[n+1] = G[n] / subst(T, x, x - 2 * n));
    for (k = 1, P[j],
      M[j,k] = vector(L, n, 1. * polcoef(G[n+1],-k)) / (k-1)!));
  return ([P, m, M]);
}

/* sum_{n <= N} v[n] u^n */
Evalvec(v, N, u) =
{ my(S = 0);
  forstep (n = min(N,#v), 1, -1, S = u * (v[n] + S));
  return (S);
}

/* K_Vga( x^(d / 2) ), x < E / C^2 is small */
Mellininvsmall(Vga, x, PmM = 0, C = 9) =
{ my(B = getlocalbitprec(), d = #Vga);
  my(x2, S, N, Ed, xd, NEWB, v, P, m, M);

  [P, m, M] = if (PmM, PmM, Mellininvsmallinit(Vga, C));
  localbitprec(32);
  Ed = log(2) * B / d;
  xd = max(Pi * abs(x), 1E-11);
  if (xd > Ed, error("should not be in Mellininvsmall"));
  N = ceil(2 * Ed / lambertw(C^2 / (exp(1) * xd)));
  NEWB = ceil(B + d * xd / log(2));
  localbitprec(NEWB);
  x = bitprecision(x, NEWB);
  x = (Pi * x)^(d / 2); x2 = x^2;
  v = powers(-log(x), vecmax(P) - 1);
  S = sum(j = 1, #P,
          x^(-m[j]) * sum(k = 1, P[j],
                          v[k] * Evalvec(M[j, k], N, x2)));
  return (bitprecision(S / Pi^(vecsum(Vga) / 2), B));
}
