/* Assuming we are in the basin of attraction and
 * |f'| is not too small, refine x using Newton.
 * T is the function f / f'. */
Newtonrefine(T, x) =
{ my(B = getlocalbitprec(), e, n, c, x0, e0, e2);

  x0 = bitprecision(x, 96); e0 = exponent(T(x0));
  e = max(exponent(1 - T'(x0)) - e0 - 1, 0);
  e2 = min(-e0, 64) - e;
  if (e2 <= 0, error("Insuficcient accuracy in Newtonrefine"));
  n = 1 + exponent((B + 32 - e) \ e2);
  c = 1 + e + (B - e) >> n;
  for (j = 1, n,
    c = 2 * c - e; x = bitprecision(x, c); x -= T(x));
  return (bitprecision(x, B));
}
