/* MOM(n) returns the 2n moments m_k for 0 <= k < 2n,
 * compute [P_n, Q_n]. */
OrthopolyCF(MOM, n) =
{ my(B = getlocalbitprec(), N = 2*n, v, M, PQ, P, Q);

  localbitprec(3*B / 2); M = MOM(n);
  if (exponent(M[2]) >= -B, /* m_1 != 0 */
    for (j = 1, N,
      if (exponent(M[j]) < -B, error("untreatable case")));
    /* normal Quodif, hope for the best */
    v = Quodif(M);
    PQ = CFback(N, j -> v[j+1] / 'x, j -> (j != 0))
  , /* else */
    forstep (j = 4, N, 2, /* m_{j-1} ~ 0 for all j */
      if (exponent(M[j]) >= -B, error("untreatable case")));
    /* Quodif with only even terms, hope for the best */
    v = Quodif(vector(n, j, M[2*j - 1]));
    my(R = 'x * CFback(n - 1, j -> v[j + 2] / 'x^2));
    PQ = v[1] / R);
  P = denominator(PQ);
  Q = numerator(PQ);
  return (bitprecision([P, Q] / pollead(P), B + 32));
}
