/* Compute prod_{p >= a, prime} F(p^s), F rational function. */
ProdEulerrat(F, s = 1, a = 2) =
{ my(B = getlocalbitprec(), vx = variable(F));
  my(FIm1, rs, N, r, lim, vF, sal, S);

  FIm1 = subst(F, vx, 1/vx) - 1;
  vF = valuation(FIm1, vx);
  rs = real(s);
  if (rs <= 1/vF, error("real(s) <= 1/v"));
  localbitprec(32);
  r = 1 / max(polrootsbound(numerator(F)),
              polrootsbound(denominator(F)));
  N = ceil(max(30, a + 1));
  if (rs <= -log(r) / log(N), error("real(s) too small"));
  lim = ceil(B * log(2) / log(N^rs * r)) + 1;
  localbitprec(B);
  sal = log(1 + bitprecision(1., B + 32)*FIm1 + O(vx^(lim+1)));
  bernvec(floor((lim * s + 1) / 2)); /* cache the B_{2n} */
  S = sum(n = vF, lim,
          my(m = Sdmob(sal, n)); if (m, m * LogzetaN(n*s, N)));
  S = exp(S);
  forprime (p = a, N, S *= subst(F, vx, p^s));
  return (bitprecision(S, B));
}
