/* merges DiffMinit and SumEulerMaclaurin2init
 * Set the ALT flag to 1 for the Sumalt variant */
DiffEulerMaclaurin(M2, om, ALT = 0) =
{ my(C, h, W, Q, N2, N, X, x = 'x);

  N2 = ceil((om+1) * M2); N2 += (N2 + 1) % 2; \\ make N2 odd
  N = N2 \ 2;
  M = M2 \ 2;
  my(B1, B = getlocalbitprec());
  B1 = ceil(B * (1 + 1 / om) + N2 + 32);
  localbitprec(B1);
  h = 1.0 >> (ceil(B / (N2 - M2)));
  my(H, ih = 1 / h);
  H = powers(ih^2, M - 1, ih / (N2-1)!);
  bernvec(M); /* initialize Bernoulli cache */
  if (ALT, H = vector(M, j, (2^(2*j)-1) * H[j]));
  H = vector(M, j, bernfrac(2*j)/(2*j) * H[j]);
  C = binomial(2 * N);uX = vector(N2); W = vector(N2);
  Q = x * vecprod(vector(N, k, x^2 - k^2));
  W = vector(N, i,
    my(L = (Q \ (x - i) + O(x^(M2+1))));
    my(S = sum(j = 1, M, H[j] * polcoef(L, 2*j-1)));
    S * C[N - i + 1] * (-1)^(N - i));
  return ([W, h]);
}

SumEulerMaclaurin3init(om = 2, a = 0) =
{ my([k, N] = SumEulerMaclaurin2kN(om, a));
  my([W, h] = DiffEulerMaclaurin(k, om, 0));
  return ([W, N, h]);
}
SumEulerMaclaurin3(f, F = 0, XW = 0) =
{ my(B = getlocalbitprec(), S, W, N, h);

  [W, N, h] = if (XW, XW, SumEulerMaclaurin3init());
  F = Sumintinit(f, F);
  localbitprec(B + 32);
  S = sum(m = 1, N - 1, f(m), f(N) / 2.) - F(N);
  localbitprec(bitprecision(h));
  S -= sum(i = 1, #W, W[i] * (f(N + h*i) - f(N - h*i)));
  return (bitprecision(S, B));
}
