LogzetaN(s, N) =
{ my(B = getlocalbitprec());

  B += ceil(abs(real(s) - 1) * exponent(2 * N));
  localbitprec(B);
  if (bitprecision(s) < B, s = bitprecision(s, B));
  log(zeta(s) * prodeuler(p = 2, N, 1 - p^(-s)));
}

Sdmob(ser, n) =
  sumdiv(n, d, moebius(d) * polcoef(ser, n / d) / d);

/* Compute sum_{p >= a, prime} F(p^s), F rational function. */
SumEulerrat(F, s = 1, a = 2) =
{ my(B = getlocalbitprec(), vx = variable(F), rs, N, r, lim);
  my(FI, vF, sal, S);

  FI = subst(F, vx, 1 / vx); vF = valuation(FI, vx);
  rs = real(s);
  if (rs <= 1 / vF, error("real(s)  <=  1/v"));
  localbitprec(32);
  r = 1 / max(polrootsbound(denominator(F)), 1);
  N = ceil(max(30, a + 1));
  if (rs <= -log(r) / log(N), error("real(s) too small"));
  lim = ceil(B * log(2) / log(N^rs * r)) + 1;
  localbitprec(B);
  sal = bitprecision(1., B + 32) * FI + O(vx^(lim+1));
  bernvec(floor((lim * s + 1) / 2)); /* cache the B_{2n} */
  S = sum(n = vF, lim,
          my(m = Sdmob(sal, n)); if (m, m * LogzetaN(n*s, N)));
  forprime (p = a, N, S += subst(F, vx, p^s));
  return (bitprecision(S, B));
}
