/* Compute sum_{n>=1}u(n)cos(2 pi nx). */
Sumcos(u, x = 1/2, tab = 0) =
{ my(B = getlocalbitprec(), B1, d, vc, S, z);

  z = (() -> exp(2*Pi*I*x));
  if (!tab, tab = Sumoscinit(z));
  [d, vc, B1] = tab;
  localbitprec(B1); vc *= z() / d;
  S = sum(j = 1, #vc, real(vc[j]) * u(j));
  return (bitprecision(S, B));
}

/* Compute sum_{n>=1}u(n)sin(2 pi nx). */
Sumsin(u, x = 1/2, tab = 0) =
{ my(B = getlocalbitprec(), B1, d, vc, S, z);

  z = (() -> exp(2*Pi*I*x));
  if (!tab, tab = Sumoscinit(z));
  [d, vc, B1] = tab;
  localbitprec(B1); vc *= z() / d;
  S = sum(j = 1, #vc, imag(vc[j]) * u(j));
  return (bitprecision(S, B));
}

/* Compute sum_{n in Z, n not 0}u(n)exp(2 pi nx). */
Sumexp(u, x = 1/2, tab = 0) =
{ my(B = getlocalbitprec(), B1, d, vc, S, z);

  z = (() -> exp(2*Pi*I*x));
  if (!tab, tab = Sumoscinit(z));
  [d, vc, B1] = tab;
  localbitprec(B1); vc *= z() / d;
  S = sum(j = 1, #vc, my(co = vc[j]);
	              co * u(j) + conj(co) * u(-j));
  return (bitprecision(S, B));
}
