/* Similar, but assume that al = 2 and f(n) = 1/n, so that
 * u(N)/2 + sum_{n > N) u(n) has a regular asymptotic expansion
 * in integral powers of 1/n^2. */

/* vu(N) = [u(1), ..., u(N)]  */
SumLagrange2vec(vu, mul = 1) =
{ my(VU);
  VU = (N -> my(S = 0., U = vu(N * mul));
             vector(N, j, my(A = (j-1)*mul + 1, B = A + mul-1);
                          S += sum(n=A, B, U[n]); S - U[B]/2));
  return (Limitvec(VU, 2));
}
SumLagrange2(u, mul = 1) =
  SumLagrange2vec(M -> vector(M, n, u(n)), mul);
