/* Monien summation when the asymptotic expansion of f
   is in integral powers of 1/n^2. */
SumMonien2init(N = 0) =
{ my(B = getlocalbitprec(), v, vr, PQ, Q, S, X, W);

  localbitprec(32);
  my(c1 = 1 - log(2) / 2, c2 = log(2) / 4);
  N = max(N, ceil(Solvemullog(c1, c2 * B))) + 1;
  localbitprec(1.1 * B + 32);
  v = vector(2 * N, m, if (m == 1, 1 / 6, 1 / (4 * m^2 - 1)));
  S = 0; forstep (n = 2 * N, 1, -1, S = v[n] * 'x / (1 + S));
  PQ = subst(1 + S, 'x, -Pi^2 * 'x);
  Q = denominator(PQ);
  vr = SumMonienroots(Q, 2, polrootsreal);
  if (poldegree(Q) != #vr,
    error("incorrect roots in SumMonien2init"));
  X = vector(N, j, sqrt(vr[j]));
  W = subst(numerator(PQ) / Q', 'x, vr);
  W = vector(N, j, W[j] / X[j]^2);
  return (bitprecision([X, W], B + 32));
}

SumMonien2(f, XW = 0) =
{
  if (type(N) != "t_VEC", XW = SumMonien2init(XW));
  SumXW(f, XW);
}
