/* Newton refinement of root z of Q. */
SumMonienrefine(Q, z) =
{ my(Qp = Q', pr, prnew);

  pr = subst(Q, 'x, z);
  while (1,
    z -= pr / subst(Qp, 'x, z); prnew = subst(Q, 'x, z);
    if (abs(prnew) < abs(pr),
      pr = prnew
    , /* else */
      z = bitprecision(z, 2 * getlocalbitprec());
      return (z - subst(Q, 'x, z) / subst(Qp, 'x, z))));
}

SumMonienroots(Q, int, roots) =
{ my(v = []);

  if (int, \\ half the roots are close to integers^int
    my(m = poldegree(Q) \ 2 - 1);
    v = vectorv(m, j, SumMonienrefine(Q, j^int));
    for (j = 1, m,
      if (exponent(v[j] - j^int) > -5, v = v[1..j]; break));
    Q \= vecprod(vector(#v, j, 'x - v[j])));
  return (concat(v, roots(Q)));
}
