SumPinelisinit(cm = 0.15) =
{ my(B = getlocalbitprec(), m = ceil(cm * B));
  my(V = binomial(2 * m), d = V[m + 1] / 2, D, X, W, S);

  D = vector(m, j, (-1)^(j-1) * V[m + j + 1] / (j * d));
  W = vector(m);
  S = 0; forstep (s = m, 1, -2, S += D[s]; W[s] = S);
  S = 0; forstep (s = m - 1, 1, -2, S += D[s]; W[s] = S);
  X = vector(m, j, (j - 1) / 2);
  return ([X, W]);
}

SumPinelis(f, F = 0, cN = 0.3, XW = 0.15) =
{ my(B = getlocalbitprec(), S, N);

  if (type(XW) != "t_VEC", XW = SumPinelisinit(XW));
  N = ceil(cN * B) - 1 / 2;
  F = Sumintinit(f, F);
  S = SumXW(x -> if (x, F(N-x) + F(N+x), F(N)), XW);
  localbitprec(B + 32);
  S = sum(n = 1, N, f(n), 0.) - S;
  return (bitprecision(S, B));
}
