/* Compute sum_{n >= 1} (-1)^{n-1}f(n) under the Abel-Plana
 * assumptions. Assume that f tends to 0 slowly at infinity
 * and has no pole z with large real part. */
alias(SumaltAbelPlanainit, IntGausscoshinit);

SumaltAbelPlana(f, isreal = 0, tab = 0) =
{ my(B = getlocalbitprec(), N2, N, S, I2);

  if (type(tab) != "t_VEC", tab = SumaltAbelPlanainit(tab));
  N = ceil(B / 3); N2 = N - 1/2;
  S = sum(n = 1, N - 1, (-1)^(n-1) * f(n), 0.);
  I2 = if (isreal, IntGausscosh(t -> real(f(N2 + I*t)), 1, tab)
                 , IntGausscosh(t -> f(N2 + I*t), 0, tab));
  return (S + (-1)^(N-1) / 2 * I2);
}
