/* Compute sum_{m >= 1} (-1)^{m-1} f(m), under the above
 * assumptions. Assume also that the derivatives can be
 * computed using power series substitutions. */
SumaltEulerMaclaurin(f) =
{ my(B = getlocalbitprec(), N, k, S, ser);

  k = ceil(0.15 * B); if (k % 2, k++);
  N = 2 * B; if (N % 2, N++);
  bernvec(k \ 2); /* initialize Bernoulli cache */
  localbitprec(B + 32);
  ser = f(N + 'x + O('x^(k+1)));
  S = sum(m = 1, N - 1, (-1)^(m-1) * f(m), -f(N)/2.)
    + sum(j = 1, k \ 2, (2^(2*j)-1) * bernfrac(2*j) / (2*j)
                        * polcoef(ser, 2*j-1), 0.);
  return (bitprecision(S, B));
}
