/* As SumaltEulerMaclaurin, computing the derivatives using
 * numerical differentiation; 'alt' variant of
 * SumEulerMaclaurin3. */

SumaltEulerMaclaurin3kN(om = 2, a = 0) =
{ my(B = getlocalbitprec(), N, k);
  localbitprec(32);
  if (!a,
    my(C = (om+1)^(om+1) / om^om);
    a = log(2) / (1 + lambertw(Pi*C)));
  k = ceil(a * B); if (k % 2, k++);
  N = ceil(k / (Pi * exp(1)) * 2^(B / k)); if (N % 2, N++);
  return ([k, N]);
}
SumaltEulerMaclaurin3init(om = 2, a = 0) =
{ my([k, N] = SumaltEulerMaclaurin3kN(om, a));
  my([W, h] = DiffEulerMaclaurin(k, om, 1));
  return ([W, N, h]);
}

SumaltEulerMaclaurin3(f, XW = 0) =
{ my(B = getlocalbitprec(), S, X, W, N);

  [W, N, h] = if (XW, XW, SumaltEulerMaclaurin3init());
  localbitprec(B + 32);
  S = sum(m = 1, N - 1, (-1)^(m-1) * f(m), -f(N) / 2.);
  localbitprec(bitprecision(h));
  S += sum(i = 1, #W, W[i] * (f(N + h*i) - f(N - h*i)));
  return (bitprecision(S, B));
}
