/* Compute sum_{n>=1} (-1)^{n-1} f(n) by EM symmetric
 * Delta_{1/2} summation. */

Sumaltdeltainit() =
{ my(B = getlocalbitprec(), N, k, S, W, w, vS);

  localbitprec(32);
  my(w = lambertw(2));
  N = ceil(log(2) * B / (w * (1 + w)) + 5); if (N%2, N++);
  k = ceil(N * w); if (k%2, k--);
  localbitprec(B + 32);
  C = vector(k, j, binomial(j - 1));
  k \= 2;
  W = vector(k, m, (-1)^m * sum(j = m, k,
	     C[2*j-1][j] * C[2*j][j-m+1] / 4^(2*j-1)));
  X = vector(k, m, m - 1 / 2);
  return ([X, W, N]);
}

Sumaltdelta(f, tab = 0) =
{ my(B = getlocalbitprec(), S);

  if (!tab, tab = Sumaltdeltainit());
  my(N = tab[3]);
  S = SumXW(x -> f(N - x) - f(N + x), tab);
  localbitprec(B + 32);
  S += sum(m = 1, N - 1, (-1)^(m-1) * f(m), -f(N)/2.);
  return (bitprecision(S, B));
}
