/* sum_{n > 0} \chi(n) u(n), \chi primitive character of
 * conductor F > 1, given by rational-valued closure chi such
 * that \chi(n) = exp(2*I*Pi * chi(n)) when (n, F) = 1 */

Sumchiinit(chi, F) =
{
  my([B, N] = SumoscinitBN(x -> exp(2*I*Pi / F)));
  my(T = vector(N), G = 0); \\ G = Gauss sum g(conj(chi))

  localbitprec(B);
  for (m = 1, F - 1,
    if (gcd(m, F) != 1, next);
    my([d, vc] = Sumoscinit0(B, N, exp(2*I*Pi * m / F)));
    my(z = exp(2*I*Pi * (m / F - chi(m))));
    T += vc * (z / d); G += z);
  return ([B, G, T]);
}

Sumchi(u, chi, F, tab = 0) =
{
  if (!tab, tab = Sumchiinit(chi, F));
  my([B, G, T] = tab);
  localbitprec(B);
  return (sum(i = 1, #T, T[i] * u(i)) / G);
}

Sumznchar(u, D) =
{ my([G, chi] = znchar(D), F = zncharconductor(G, chi));
  if (G.mod != F, error("non-primitive character"));
  return (Sumchi(u, n -> chareval(G, chi, n), F));
}
