/* Compute sum_{m >= 1} chi(m)f(m), assuming chi and f are
 * given by closures. */
SumchiEulerMaclaurininit(chi, FCHI) =
{ my(B = getlocalbitprec(), B0, k, bvec);

  B0 = ChiBernoulli(chi, FCHI, 0);
  localbitprec(32); k = floor(log(2) * B);
  localbitprec(B);
  bvec = vector(k, j, (-1)^j * ChiBernoulli(chi, FCHI, j) / j);
  return ([B0, bvec]);
}

SumchiEulerMaclaurin(f, F = 0, chi, FCHI, tab = 0) =
{ my(B = getlocalbitprec(), NF, S1, S2 = 0, S3, ser);

  if (!tab, tab = SumchiEulerMaclaurininit(chi, FCHI));
  my([B0, bchivec] = tab, k = #bchivec);
  NF = FCHI * ceil(0.1104*B);
  S1 = sum(m = 1, NF, chi(m) * f(m), 0.);
  if (exponent(B0) >= 7 - B,
    F = Sumintinit(f, F); S2 = -F(NF));
  ser = f(NF + 'x + O('x^(k + 1)));
  S3 = sum(j = 1, k, bchivec[j] * polcoef(ser, j - 1), 0.);
  return (S1 + S2 - S3);
}
