/* Compute sum_{i>=1}(D/i)u(i), D fundamental discriminant. */

Sumchiquadinit(D) =
{ my(B = getlocalbitprec(), w, Q, Da = abs(D), R, T, N, c);

  localbitprec(32);
  w = exp(2*I*Pi / Da);
  c = (2*log(2)) / log(norm(1 - 2*w + 2*sqrt(w^2 - w)));
  N = ceil(abs(c) * B);
  w = Mod('a, polcyclo(Da, 'a));
  [R,Q] = divrem(polchebyshev(N, 1, 1 - 2*'x), 'x - w);
  R = lift(Vecrev(R / Q)) * sign(D);
  T = (lift(sum(i=1,Da-1,kronecker(D,i)*subst(R,'a,w^i))
          / sum(i=1,Da-1,kronecker(D,i)*w^i)));
  return ([B + exponent(T), T]);
}

Sumchiquad(u, D, tab = 0) =
{
  if (!tab, tab = Sumchiquadinit(D));
  my([B1, T] = tab);
  localbitprec(B1);
  return (sum(i = 1, #T, T[i] * u(i), 0.));
}
