/* Compute sum_{m, n >= 1} f(m, n), where f is given as a
 * closure with two arguments. Do not assume that f is
 * defined over the positive reals. */
Sumdouble(f, alf = 1, mul = 1) =
{ my(B = getlocalbitprec(), S1, S2);

  localbitprec(3/2 * B);
  S1 = SumLagrange(n -> sum(m = 1, n-1, f(m,n), 0.), alf, mul);
  S2 = SumLagrange(m -> sum(n = 1,   m, f(m,n), 0.), alf, mul);
  return (bitprecision(S1 + S2, B));
}

/* Summing over diagonals m + n = cst: halve workload */
Sumdoublediag(f, alf = 1, mul = 1) =
{ my(B = getlocalbitprec(), S);

  localbitprec(3/2 * B);
  S = SumLagrange(n -> sum(k=1, n, f(k,n+1-k), 0.), alf, mul);
  return (bitprecision(S, B));
}
