/* Define U[a] := sum_{n >= 0} 2^n u(a 2^n),
 * set U[k * 2^i] for all k * 2^i <= N, in place. We assume
 * u regular to have a reasonable stopping criterion. */
SumposU(~U, u, k, E) =
{ my(N = #U, t = 0, L = exponent(N \ k)); \\ L = [log2(N/k)]
  for (i = 0, oo, \\ first compute U[k * 2^L]
    my(z = (u(k << (L + i)) * 1.) << i);
    if (!z || exponent(z) < E - L, break);
    t += z);
  U[k << L] = t; \\ then use U[j] = 2 U[2j] + u(1+j)
  forstep (i = L-1, 0, -1, U[k<<i] = t = u(k<<i) + t << 1);
}

/* Given a nonnegative sequence u as a closure, compute
 * S = sum_{n>=1} u(n). */
Sumpos(u) =
{ my(B = getlocalbitprec(), N, U, E = -B - 5);
  localbitprec(32); N = ceil(B * log(2) / log(3+sqrt(8)));
  localbitprec(B + 32); U = vector(N);
  forstep (k = 1, N, 2, SumposU(~U, u, k, E));
  localbitprec(B); Sumalt(n -> U[n]);
}
